SystemOrganization addCategory: #'GMF-GraphicModel'!

Object subclass: #DataClass
	instanceVariableNames: 'metaModelClass positionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!DataClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:25'!
mmClass: XmetaModelClass pClass: XpositionClass
	^ super new
		initialize;
		metaModelClass: XmetaModelClass;
		positionClass: XpositionClass;
		yourself! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
metaModelClass
	^metaModelClass! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
metaModelClass: xClass
	metaModelClass := xClass.! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
positionClass
	^positionClass! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
positionClass: xClass
	positionClass := xClass.! !

Object subclass: #DrawDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovak 12/1/2013 22:02'!
draw: dataModel
	Drawer clear.
	dataModel elements do:[ :d | (d metaModelClass isClass) ifTrue:[ self drawClass: d.]
					      ifFalse:[self drawassociation: d] ].! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovak 12/2/2013 01:23'!
drawClass: xClass
	| x y mmClass pClass |
	"Setup needed variables."
	mmClass := xClass metaModelClass.
	pClass := xClass positionClass.
	x := xClass positionClass leftTopPoint x + 5.
	y := xClass positionClass leftTopPoint y + 5.
	
	"Draw box with name and type"
	Drawer rectangleX: pClass leftTopPoint Y: pClass rightBottomPoint.
	Drawer textString: '<<' , mmClass class name asString , '>>' X: (Point x: x y: y).
	y := y + 25.
	Drawer textString: mmClass name X: (Point x: x y: y).
	y := y + 25.
	
	"Draw variables"
	Drawer lineX: (Point x: x - 5 y: y) Y: (Point x: pClass rightBottomPoint x y: y).
	mmClass attributs
		do: [ :d | 
			Drawer textString: d name , ':' , d dataType , '[' , d quantity asString , ']' X: (Point x: x y: y).
			y := y + 25 ].
	
	"Draw methods"
	Drawer lineX: (Point x: x - 5 y: y) Y: (Point x: pClass rightBottomPoint x y: y).
	mmClass methods
		do: [ :d | 
			Drawer
				textString:
					d name , '(' , (d parameters inject: '' into: [ :str :a | str , a , ',' ]) , ')' , ':' , d returnDataType
				X: (Point x: x y: y).
			y := y + 25 ]! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovak 12/5/2013 21:39'!
drawassociation: xAssociation
	| mmClass pClass |
	mmClass := xAssociation metaModelClass.
	pClass  := xAssociation positionClass.
	pClass lines do:[:l | Drawer lineX: l start Y: l end ].
	Drawer textString: mmClass startQuantity asString X: (Point x: (pClass start x)+15 y: (pClass start y)).
	Drawer textString: mmClass endQuantity asString X: (Point x: (pClass end x)-15 y: (pClass end y)).
	Drawer textString: mmClass name asString X: ( Point x: (pClass middlePoint x) y: (pClass middlePoint y)).
	! !

Object subclass: #Drawer
	instanceVariableNames: ''
	classVariableNames: 'fillColor font lineColor lineWidth scale surface transformX transformY'
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!Drawer commentStamp: '<historical>' prior: 0!
A Drawer is me and I would like to draw.

Class Variables
	fillColor:		<Color>
	lineColor:		<Color>
	lineWidth:		<Integer>
	surface:		<AthensCairoSurface>
	font:			<LogicalFont>

fillColor
	- filling for rectangles

lineColor
	- color of lines for lines and rectangle's edges too

lineStyle
	- style of lines for lines and rectangle's edges too

lineWidth
	- width of lines for lines and rectangle's edges too

surface
	- surface where to draw to

font
	- font to text methods!

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:03'!
clear
	surface drawDuring: [ :canvas | surface clear: Color white ].! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:26'!
fillColor
	"getter of Color for filling"

	^ fillColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:51'!
fillColor: xColor
	"setter of Color for fillin"

	fillColor := xColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
font
	"getter of font"

	^ font! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/14/2013 00:52'!
font: xFont
	"setter of font"

	font := xFont! !

!Drawer class methodsFor: 'initialization' stamp: 'RostislavNovak 12/1/2013 22:14'!
initialize 

	font := LogicalFont familyName: 'Arial' pointSize: 15.
	fillColor := Color white.
	lineColor := Color black.
	lineWidth := 3.
	transformX := transformY := 0.
	scale = 1.0.! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineColor
	"getter of Color for lines"

	^ lineColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineColor: xColor
	"setter of Color for lines"

	lineColor := xColor! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:17'!
lineDashedX: xPoint Y: yPoint dash:anInteger
	"drawing of line X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			| stroke |
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			stroke := canvas setStrokePaint: lineColor.
			stroke
				width: lineWidth;
				joinRound;
				capRound;
				dashes: ( Array braceWith:anInteger with: (3/4)*anInteger ) offset: 0.
			canvas draw
		].
	^self! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:17'!
lineEndDiamondX: xPoint Y: yPoint len:anInteger
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"
"TO DO - zatim funkce line"
	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:17'!
lineEndTriangleX: xPoint Y: yPoint len:anInteger
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"
"TO DO - zatim funkce line"
	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineWidth
	"getter of width for lines"

	^ lineWidth! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineWidth: xInteger
	"setter of width for lines"

	lineWidth := xInteger! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:16'!
lineX: xPoint Y: yPoint
	"drawing of line X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/1/2013 22:44'!
moveSurfaceX: xX Y: xY
	transformX := transformX + xX.
	transformY := transformY+xY.! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 23:22'!
rectangleX: xPoint Y: yPoint
	"drawing of rectangle
	uses fillColor for filling
	uses lineColor and lineWidth for edges
	X and Y are absolute"
	
	| path |
	scale ifNil:[scale := 1.0].
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: 	xPoint;
						lineToX: xPoint x Y: yPoint y;
						lineTo: 		yPoint;
						lineToX: yPoint x Y: xPoint y;
						close
					].
			canvas setShape: path.
			
			canvas setPaint: fillColor.
			canvas draw.
			
			(canvas setStrokePaint: lineColor) width: lineWidth ; joinRound.
			canvas draw
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/1/2013 23:07'!
scale
	^scale! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/1/2013 22:01'!
setScale: value
	scale := scale * value.! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/2/2013 00:08'!
shift
	^Point x: transformX y: transformY.! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
surface
	"getter of surface"

	^ surface! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
surface: xSurface
	"setter of surface"

	surface := xSurface! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 23:19'!
textString: aString X: aPoint
	"drawing of text"

	"| font |
	font := LogicalFont familyName: 'Arial' pointSize: 20."

	surface
		drawDuring: [ :canvas | 
			canvas pathTransform
				translateX: aPoint x * scale + transformX
				Y: (aPoint y + font getPreciseAscent) * scale + transformY.
			canvas pathTransform scaleBy: scale.
			canvas
				setFont: font;
				setPaint: lineColor.
			canvas drawString: aString ].
	^ self! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
textString: aString X: aPoint maxWidth: anInteger
	"drawing of text into closed area"

	| shortedString |
	
	shortedString := aString.
	[ (font widthOfString: shortedString) > anInteger ] whileTrue: 
		[ shortedString := shortedString copyFrom: 1 to: shortedString size - 1 ]. "uneficient for long strings, TODO maybe later"
	
	^self textString: shortedString X: aPoint.! !

Object subclass: #PositionClass
	instanceVariableNames: 'leftTopPoint rightBottomPoint middlePoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!PositionClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 14:03'!
leftTopPoint: xPoint rightBottomPoint: xxPoint
	^ super new
		initialize;
		leftTopPoint: xPoint;
		rightBottomPoint: xxPoint;
		yourself! !

!PositionClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:48'!
new
	^ super new
		initialize;
		yourself! !

!PositionClass methodsFor: 'initialize-release' stamp: 'RostislavNovak 11/14/2013 21:30'!
initialize 
	leftTopPoint := Point x: 15 y: 15.
	rightBottomPoint := Point x: 165 y: 165.
	middlePoint := Point x: 0 y: 0.
	self refreshMiddle.! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/2/2013 00:01'!
isIn: xPoint
	| rec |
	Transcript show: leftTopPoint.
	Transcript show: '<'.
	Transcript show: xPoint.
	Transcript show: '<'.
	Transcript show: rightBottomPoint; cr.
	rec := Rectangle origin: leftTopPoint  corner: rightBottomPoint.
	^rec containsPoint: xPoint.
	! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
leftTopPoint
	^ leftTopPoint! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
leftTopPoint: anObject
	leftTopPoint := anObject! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
middlePoint
	^ middlePoint! !

!PositionClass methodsFor: 'private' stamp: 'RostislavNovk 11/3/2013 14:02'!
middlePoint: anObject
	middlePoint := anObject! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/5/2013 21:43'!
move: xPoint
	leftTopPoint := leftTopPoint + xPoint.
	rightBottomPoint := rightBottomPoint  + xPoint.
	self refreshMiddle.! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:39'!
refreshMiddle
	middlePoint := Point x: (leftTopPoint x + rightBottomPoint x) / 2 y: (leftTopPoint y + rightBottomPoint y) / 2! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
rightBottomPoint
	^ rightBottomPoint! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
rightBottomPoint: anObject
	rightBottomPoint := anObject! !

PositionClass subclass: #PositionLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

PositionLine subclass: #PositionGroupOfLines
	instanceVariableNames: 'lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!PositionGroupOfLines class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:55'!
new 
	^super new initialize; yourself.! !

!PositionGroupOfLines methodsFor: 'initialize-release' stamp: 'RostislavNovk 11/3/2013 13:54'!
initialize
	lines := OrderedCollection new.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:54'!
lines
	^ lines copy.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:36'!
lines: anObject
	lines add: anObject.
	self refreshPosition.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:39'!
refreshPosition
	super leftTopPoint: lines first start.
	super rightBottomPoint: lines last end.
	self refreshMiddle.! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
end
	^rightBottomPoint! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
end: anObject
	rightBottomPoint := anObject! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
start
	^leftTopPoint ! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
start: anObject
	leftTopPoint := anObject! !
Drawer initialize!
